DROP FUNCTION time_series_pack (text);
DROP FUNCTION time_series_unpack (bytea, integer);
DROP FUNCTION time_series_unpack3 (bytea, integer, integer, integer);
DROP FUNCTION join_packed_time_series (bytea, bytea);

DROP TYPE _time_series;
DROP TYPE _time_series3;

CREATE TYPE _time_series  AS (row integer, f float4);
CREATE TYPE _time_series3 AS (row integer, f1 float4, f2 float4, f3 float4);

CREATE OR REPLACE FUNCTION time_series_pack (text) RETURNS bytea 
  AS 'tseries.so','time_series_pack' LANGUAGE C;

CREATE OR REPLACE FUNCTION time_series_unpack (bytea, integer) RETURNS SETOF _time_series
  AS 'tseries.so','time_series_unpack' LANGUAGE C;

CREATE OR REPLACE FUNCTION time_series_unpack3 (bytea, integer, integer, integer) RETURNS SETOF _time_series3
  AS 'tseries.so','time_series_unpack3' LANGUAGE C;

CREATE OR REPLACE FUNCTION join_packed_time_series(bytea, bytea) RETURNS bytea 
  AS 'tseries.so','join_packed_time_series' LANGUAGE C;
